/*
 * Universidade Federal de Pernambuco - UFPE
 * Centro de Informtica - CIn
 * Centro Integrado de Tecnologia da Informao - CITi
 * Curso de C/C++
 * Autor: Allan Lima - http://allanlima.wordpress.com/
 * Instrutor: Luiz Felipe Sotero (lfss@cin.ufpe.br)
 *
 * Retangulo.h - Arquivo que contm a definio da classe Retangulo
 */

#ifndef _RETANGULO_H_
#define _RETANGULO_H_

class Retangulo {
	private:
		int altura;
		int largura;

	protected:

		// Modifica a altura do retntulo
		void setAltura(int a);

		// Modifica a largura do retntulo
		void setLargura(int l);

	public:

		// Contrutor da classe, inicializa os seus do retngulo
		Retangulo(int a = 1, int l = 1);

		// Retorna a altura do retngulo, este mtodo  in-line para aumentar a performance do programa
		int getAltura() {
			return this->altura;
		}

		// Retorna a largura do retngulo, este mtodo  in-line para aumentar a performance do programa
		int getLargura() {
			return this->largura;
		}

		// Calcula o permetro do retngulo
		int perimetro();

		// Calcula a rea do retngulo
		int area();

		// Compara dois retngulos. A varivel  uma referncia para o retngulo original.
		bool equals(Retangulo &r);
};

#endif //_RETANGULO_H_
