/*
 * Universidade Federal de Pernambuco - UFPE
 * Centro de Informtica - CIn
 * Centro Integrado de Tecnologia da Informao - CITi
 * Curso de C/C++
 * Autor: Allan Lima - http://allanlima.wordpress.com/
 * Instrutor: Luiz Felipe Sotero (lfss@cin.ufpe.br)
 *
 * comparativo.cpp - Exemplo das difenas entre C e C++
 */

#include <iostream>
#include <string> // diferente de string.h de C

using namespace std;

/*
 * Demonstra como utilizar referncias como parmetros de uma funo.
 * Os parmetros a e b podem ser utilizados como se fossem inteiros.
 */
void swap(int &a, int &b) {
    int temp = a;
    a = b;
    b = temp;
}

/*
 * Demonstra a possibilidade de se criar uma funo com o mesmo nome de uma
 * outra definida anteriormente, porm com prottipos distintos.
 */
void swap(float &a, float &b) {
    float temp = a;
    a = b;
    b = temp;
}

/*
 * Demonstra como setar o valor default de um argumento da funo.
 */
int mult(int a = 2, int b = 1) {
    return a * b;
}
/*
int main() {
    int a = 10;
    float f = float(a); // novo tipo de cast

    cout << "f = " << f << endl;

    int b = 20; // varivel declarada no meio do bloco

    cout << "Antes:  a =  " << a << ", b = " << b << endl;
    swap(a, b);  // o compilador trata de chamar a funo correta
    cout << "Depois: a =  " << a << ", b = " << b << endl;

    float d = 45.5; // varivel declarada no meio do bloco

    cout << "Antes:  f =  " << f << ",   d = " << d << endl;
    swap(f, d); // o compilador trata de chamar a funo correta
    cout << "Depois: f =  " << f << ", d = " << d << endl;

    cout << "mult(a, b) = " << mult(a, b) << endl;
    cout << "mult(a) = " << mult(a) << endl;
    cout << "mult() = " << mult() << endl;

    // Alocao de memria com o new
    int *array = new int[10];

	// Inicializa o array
    for (int i = 0; i < 10; i++) {
        array[i] = i;
    }

	// imprime o array
    cout << "Array: ";
    for (int j = 0; j < 10; j++) {
        cout << array[j] << " ";
    }

	// apaga o array da memria
    delete [] array;

    cout << endl; // endl == '\n'

    // ES
    cout << "Qual o seu nome? ";

    string nome; // em C++ existe um tipo chamado string

    cin >> nome; // cin permite a leitura de dados da entrada padro

    cout << "Ola " << nome << endl;

    // Substitui a funo getchar()
    cin.get();

    return 0;
}*/

